#include "mainwindow.h"
#include "ui_mainwindow.h"


uint video_number_of_frames;
uint CurrentFrame;

void MainWindow::CaptureStart()  // check and start the camera/video stream
{

if(SourceReady == true)
{

if(Source == "Webcam")
{FinalCapture = CameraCapture;}
if(Source == "Video")
{FinalCapture = Video_Cap;

FinalCapture.set(CV_CAP_PROP_POS_FRAMES,0); // set the video on start

// get the video parameters

video_current_frame = FinalCapture.get(CV_CAP_PROP_POS_FRAMES);
video_frame_rate = FinalCapture.get(CV_CAP_PROP_FPS);
video_number_of_frames = FinalCapture.get(CV_CAP_PROP_FRAME_COUNT);
capture_format= FinalCapture.get(CV_CAP_PROP_FOURCC);
capture_width= FinalCapture.get(CV_CAP_PROP_FRAME_WIDTH);
capture_height= FinalCapture.get(CV_CAP_PROP_FRAME_HEIGHT);

}


FinalCapture.open(0);
if(FinalCapture.isOpened())
{
CameraStream = true;
FinalCapture>>RawImage;
RawImage.copyTo(DestinationImage); // first frame was copied to the destination image to get dest image parameters in thread on start


TrackingStart(); // start the tracking

CameraTimer = new QTimer(this);
connect(CameraTimer,SIGNAL(timeout()),this,SLOT(GrabCaptureFrame()));
CameraTimer->start(CameraDelay);

mServer.CreateServer(Port); // create server for tracking data and set port

}

}
}


void MainWindow::CaptureStop() // stop the camera stream
{
CameraTimer->stop();
CameraStream = false;
mServer.DeleteServer(); // delete server
}


void MainWindow::GrabCaptureFrame()
{
if(HoldFrame == false){

if(Source == "Video")
{
video_current_frame++;
if(video_current_frame == video_number_of_frames)
{
FinalCapture.set(CV_CAP_PROP_POS_FRAMES,0);
video_current_frame = 0;
}
FinalCapture>>RawImage;

}
else
{ FinalCapture>>RawImage; }


}
emit emit_frame(&RawImage);
RefreshScreen();
}


