#include "mainwindow.h"
#include "ui_mainwindow.h"
#include "my_qlistwidget.h"

void MainWindow::Start() // this function sets all variables and check if there is any camera avaliable
{

QIcon icon("Icon.tif");
this->setWindowIcon(icon);



this->setWindowTitle("Face Tracker 1.0");

CameraDelay = 30; // set the default camera delay to 30ms.
CameraStream = false;

connect(ui->L_Screen, SIGNAL(Mouse_Pos()),this,SLOT(MouseCurrentPos()));  // ste up connections for mouse events
connect(ui->L_Screen, SIGNAL(Mouse_Pressed()),this,SLOT(MousePressed()));
connect(ui->L_Screen, SIGNAL(Mouse_Left()),this,SLOT(MouseLeft()));
ui->L_Screen->setProperty("cursor", QVariant(QCursor(Qt::CrossCursor))); // set up the cursor for the left screen

H_value=0;
S_value=0;
V_value=0;
T_value=0;
R_value=30;

LipsB = 0.5;
LipsG = 2;


EyesAreaSize = 16;
EyesDarkPoint = 16;
EyesMaxMov = 16;
EyesMinMov = 12;
EyesBlur = 1;
EyesDepth = 3;
EyesFastTracking = false;


ui->Slider_L_G->setValue(200);
ui->Slider_L_B->setValue(50);

ui->Slider_E_Roi->setValue(EyesAreaSize);
ui->Slider_E_Brith->setValue(EyesDarkPoint);
ui->Slider_E_Max->setValue(EyesMaxMov);
ui->Slider_E_Min->setValue(EyesMinMov);
ui->Slider_E_Blur->setValue(EyesBlur);
ui->Slider_E_D->setValue(EyesDepth);
ui->E_CH->setChecked(EyesFastTracking);


ui->E_V_P->setText(QString::number(EyesAreaSize));
ui->E_V_Brith->setText(QString::number(EyesDarkPoint));
ui->E_V_Max->setText(QString::number(EyesMaxMov));
ui->E_V_Min->setText(QString::number(EyesMinMov));
ui->E_V_Blur->setText(QString::number(EyesBlur));
ui->E_V_D->setText(QString::number(EyesDepth));



EbAccurateMode = true;
EbBlur1 = 16;
EbBlur2 = 1;

ui->Slider_EB_B->setValue(EbBlur1);
ui->Slider_EB_B_2->setValue(EbBlur2);


ui->EB_V_B->setText(QString::number(EbBlur1));
ui->EB_V_B_2->setText(QString::number(EbBlur2));


ZoomOnOff = false;
EmitPermission = true;


ui->comboBox_R_Screen->addItem("1: Trackers");
ui->comboBox_R_Screen->addItem("2: Mask");
ui->comboBox_R_Screen->addItem("3: Fixed Trackers");






ThreadIsRunning = false;









if(CheckWebcam() == true)
{
ui->comboBox_Sources->addItem("1: Webcam");
ui->comboBox_Sources->addItem("2: Video");
Source = "Webcam";
CountOfItems = 2;
SourceReady = true;
ui->Button_Camera->setEnabled(true);
}
else
{
ui->comboBox_Sources->addItem("1: Video");
Source = "Video";
CountOfItems = 1;
SourceReady = false;
ui->Button_Camera->setEnabled(false);
}
ui->Button_Hold_Frame->setEnabled(false);


ui->Button_DeleteColor->setEnabled(false);
ColorChannel = 0;
HoldFrame = false;


ColorTrack = false;
ui->Button_TrackingMethod->setText("Color Track On");


////// SETUP THE IP/PORT SETTINGS //////////////

Port = "1234";
ui->textInputPort->append(Port);



current_path =  QDir::currentPath();



}



