#include "mainwindow.h"
#include "ui_mainwindow.h"
#include <QThread>
#include "threadworker.h"



void MainWindow::TrackingStart()
{

if (ThreadIsRunning == false)
{

QThread* thread = new QThread;
ThreadWorker*  worker = new ThreadWorker;
worker->moveToThread(thread);
connect(this,SIGNAL(emit_addresses(Mat*,QString*)),worker,SLOT(Initialize(Mat*,QString*)));
connect(this,SIGNAL(emit_frame(Mat*)),worker,SLOT(Tracker(Mat*)));
connect(this, SIGNAL(emit_mouse_position(Point*)),worker,SLOT(MouseLeft(Point*)));
connect(this,SIGNAL(emit_HSV_data(uint*,uint*,uint*,uint*)),worker,SLOT(Get_HSV_Data(uint*,uint*,uint*,uint*)));
connect(this,SIGNAL(emit_LIPS_data(float*,float*)),worker,SLOT(Get_LIPS_Data(float*,float*)));
connect(this,SIGNAL(emit_EYES_data(uint*,uint*,uint*,uint*,uint*,uint*,bool*)),worker,SLOT(Get_EYES_Data(uint*,uint*,uint*,uint*,uint*,uint*,bool*)));
connect(this,SIGNAL(emit_EB_data(uint*,uint*)),worker,SLOT(Get_EB_Data(uint*,uint*)));
connect(this,SIGNAL(emit_ComboBoxIndex(uint*)),worker,SLOT(Get_ComboBoxIndex(uint*)));
connect(this,SIGNAL(emit_ColorIndex(uint*)),worker,SLOT(Get_ColorIndex(uint*)));
connect(this,SIGNAL(emit_TrackingMethod(bool*)),worker,SLOT(Get_TrackingMethod(bool*)));
connect(this,SIGNAL(emit_StartFunction()),worker,SLOT(Start()));
emit emit_addresses(&DestinationImage,&TrackingData);
emit emit_TrackingMethod(&ColorTrack);
emit emit_ComboBoxIndex(&ComboBoxIndex);
emit emit_EYES_data(&EyesAreaSize,&EyesDarkPoint,&EyesMaxMov,&EyesMinMov,&EyesBlur,&EyesDepth,&EyesFastTracking);
emit emit_EB_data(&EbBlur1,&EbBlur2);
thread->start();
ThreadIsRunning = true;
   // on_Button_Hold_Frame_clicked();

}
else
{

emit emit_StartFunction();
emit emit_TrackingMethod(&ColorTrack);
emit emit_addresses(&DestinationImage,&TrackingData);
emit emit_TrackingMethod(&ColorTrack);
emit emit_ComboBoxIndex(&ComboBoxIndex);
emit emit_EYES_data(&EyesAreaSize,&EyesDarkPoint,&EyesMaxMov,&EyesMinMov,&EyesBlur,&EyesDepth,&EyesFastTracking);
emit emit_EB_data(&EbBlur1,&EbBlur2);

}

}



