#include "threadworker.h"



void ThreadWorker::Drawer()
{


/*
/////////////////////////////////////////////// POINTS ////////////////////////////////////////////////////

rectangle(Frame_Trackers, RoiPoints[0], RoiPoints[1], CV_RGB(0,255,0));  // face
rectangle(Frame_Trackers, RoiPoints[2],RoiPoints[3], CV_RGB(0,0,255)); // L eye ROI
rectangle(Frame_Trackers, RoiPoints[4] ,RoiPoints[5], CV_RGB(255,0,0)); // R eye ROI
rectangle(Frame_Trackers, RoiPoints[2] ,RoiPoints[5], CV_RGB(128,128,128)); // Eyes  ROI
rectangle(Frame_Trackers, RoiPoints[6],RoiPoints[7], CV_RGB(0,255,255)); // mouth area
*/


Point MiddlePoint(Frame.cols/2,Frame.rows/2);
uint shift = 64;
Point LU((MiddlePoint.x - (Frame.rows/2) + shift),(MiddlePoint.y - (Frame.rows/2) + shift));
Point RD((MiddlePoint.x + (Frame.rows/2) - shift),(MiddlePoint.y + (Frame.rows/2) - shift));


if(ComboBoxIndex == 0)
{

cv::circle(Frame_Trackers,Trackers[1],4, CV_RGB(255,128,0),-1); // eyebrow
cv::circle(Frame_Trackers,Trackers[2],4, CV_RGB(255,128,0),-1);
cv::circle(Frame_Trackers,Trackers[3],4, CV_RGB(255,128,0),-1);
cv::circle(Frame_Trackers,Trackers[4],4, CV_RGB(0,128,255),-1);
cv::circle(Frame_Trackers,Trackers[5],4, CV_RGB(0,128,255),-1);
cv::circle(Frame_Trackers,Trackers[6],4, CV_RGB(0,128,255),-1);


cv::circle(Frame_Trackers,Trackers[7],4, CV_RGB(255,0,0),-1); // eyes
cv::circle(Frame_Trackers,Trackers[8],4, CV_RGB(0,0,255),-1);
cv::line(Frame_Trackers, Trackers[7], Trackers[8], CV_RGB(0,255,0), 1,8,0);


cv::circle(Frame_Trackers,Trackers[9],4, CV_RGB(255,0,0),-1); // mouth
cv::circle(Frame_Trackers,Trackers[10],4, CV_RGB(0,255,0),-1);
cv::circle(Frame_Trackers,Trackers[11],4, CV_RGB(0,0,255),-1);
cv::circle(Frame_Trackers,Trackers[12],4, CV_RGB(255,255,255),-1);




rectangle(Frame_Trackers,LU, RD, CV_RGB(0,255,0),1,8);  // focus area



Rect Bar(Point(LU.x,RD.y),Point(RD.x,RD.y + 48));
rectangle(Frame_Trackers,Bar, CV_RGB(0,0,0),-1,8);


std::ostringstream textAngle; // Head Angle
int Angle  = HeadAngle;
Angle = abs(Angle);
if(HeadAngle>0){textAngle<<"Angle:+"<<Angle;}
if(HeadAngle<0){textAngle<<"Angle:-"<<Angle;}
if(HeadAngle==0){textAngle<<"Angle: "<<Angle;}
putText(Frame_Trackers,textAngle.str(),Point(LU.x,RD.y + 24),FONT_HERSHEY_PLAIN,2,Scalar(255,255,255),2,8,false);


std::ostringstream textGaze; // Gaze
textGaze<<"Gaze:";
putText(Frame_Trackers,textGaze.str(),Point(LU.x+155,RD.y + 24),FONT_HERSHEY_PLAIN,2,Scalar(255,255,255),2,8,false);

double GazeSizeL,GazeSizeR;
if(GazeDirection > 0)
{GazeSizeR = abs(GazeDirection)*50; GazeSizeL = 5; }
if(GazeDirection < 0)
{GazeSizeL = abs(GazeDirection)*50; GazeSizeR = 5; }
if(GazeDirection == 0)
{GazeSizeL = 5; GazeSizeR = 5; }

Rect GazeBar;
GazeBar.x = LU.x+300-50;
GazeBar.y = RD.y + 8;
GazeBar.height = 16;
GazeBar.width = 100 ;
rectangle(Frame_Trackers,GazeBar, CV_RGB(0,255,0),2,8);

Rect GazeBarR;
GazeBarR.x = LU.x+300;
GazeBarR.y = RD.y + 8;
GazeBarR.height = 16;
GazeBarR.width = GazeSizeR ;
rectangle(Frame_Trackers,GazeBarR, CV_RGB(0,0,255),-1,8);

Rect GazeBarL;
GazeBarL.x = LU.x+300;
GazeBarL.y = RD.y + 8;
GazeBarL.height = 16;
GazeBarL.width =  GazeSizeL;
GazeBarL.x -=GazeBarL.width;

rectangle(Frame_Trackers,GazeBarL, CV_RGB(255,0,0),-1,8);
if(ColorTrack == true)
{
    cv::circle(Frame_Trackers,Point(Frame.cols-shift,Frame.rows - shift/1.5),16, CV_RGB(0,0,255),-1);
    cv::circle(Frame_Trackers,Point(Frame.cols-shift-16,Frame.rows - shift/1.5),16, CV_RGB(0,255,0),-1);
    cv::circle(Frame_Trackers,Point(Frame.cols-shift-32,Frame.rows - shift/1.5),16, CV_RGB(255,0,0),-1);

}
else
{
    cv::circle(Frame_Trackers,Point(Frame.cols-shift,Frame.rows - shift/1.5),16, CV_RGB(96,96,96),-1);
    cv::circle(Frame_Trackers,Point(Frame.cols-shift-16,Frame.rows - shift/1.5),16, CV_RGB(168,168,168),-1);
    cv::circle(Frame_Trackers,Point(Frame.cols-shift-32,Frame.rows - shift/1.5),16, CV_RGB(220,220,220),-1);
}

}

if(ComboBoxIndex == 2)// Fixed trackers
{
for(int i=1;i<=12;i++)
{
cv::circle(Frame_FixedTrackers,sTrackers[i],4, CV_RGB(255,255,255),-1);
if(i == 7 || i== 8)
{cv::circle(Frame_FixedTrackers,sTrackers[i],8, CV_RGB(0,128,255),2);}
}
cv::circle(Frame_FixedTrackers,MiddlePoint,4, CV_RGB(128,128,128),-1);
if(ColorTrack == true)
{
    cv::circle(Frame_FixedTrackers,Point(Frame.cols-shift,Frame.rows - shift/1.5),16, CV_RGB(0,0,255),-1);
    cv::circle(Frame_FixedTrackers,Point(Frame.cols-shift-16,Frame.rows - shift/1.5),16, CV_RGB(0,255,0),-1);
    cv::circle(Frame_FixedTrackers,Point(Frame.cols-shift-32,Frame.rows - shift/1.5),16, CV_RGB(255,0,0),-1);

}
else
{
    cv::circle(Frame_FixedTrackers,Point(Frame.cols-shift,Frame.rows - shift/1.5),16, CV_RGB(96,96,96),-1);
    cv::circle(Frame_FixedTrackers,Point(Frame.cols-shift-16,Frame.rows - shift/1.5),16, CV_RGB(168,168,168),-1);
    cv::circle(Frame_FixedTrackers,Point(Frame.cols-shift-32,Frame.rows - shift/1.5),16, CV_RGB(220,220,220),-1);
}
}
//////////////////////////////////////////////////////////////////////////////////////////////////////////
}



