#include "threadworker.h"



Point ThreadWorker::RotatePoint(Point Pivot,Point PointToRotate,double AngleAlpha)
{
double Angle =   AngleAlpha *(PI/180);
Point Fin;
Fin.x = (cos(Angle)*(PointToRotate.x - Pivot.x)) - (sin(Angle)*(PointToRotate.y-Pivot.y)) + Pivot.x;
Fin.y = (sin(Angle)*(PointToRotate.x - Pivot.x)) + (cos(Angle)*(PointToRotate.y-Pivot.y)) + Pivot.y;
return Fin;
}



bool ThreadWorker::IsPointInsideRoi(Point InspectedPoint, Point LP_Point, Point RD_Point)
{

if(InspectedPoint.x > LP_Point.x && InspectedPoint.y > LP_Point.y && InspectedPoint.x < RD_Point.x && InspectedPoint.y < RD_Point.y )
{
return true;
}
else
{
return false;
}

}



bool ThreadWorker::IsPointInsideRect(Point InspectedPoint, Rect InspectedRect)
{

Point LP_Point(InspectedRect.x,InspectedRect.y);
Point RD_Point(InspectedRect.x + InspectedRect.width,InspectedRect.y + InspectedRect.height);

if(InspectedPoint.x > LP_Point.x && InspectedPoint.y > LP_Point.y && InspectedPoint.x < RD_Point.x && InspectedPoint.y < RD_Point.y )
{
return true;
}
else
{
return false;
}

}


void ThreadWorker::GetPupilDistance() //PUPIL DISTANCE CHECK ////////////////////
{
   double ActualDistance,AverageDistance,x,y,ratio;
   if(CycleDetected > 4) // fill the buffer
   {
   ActualDistance = sqrt(pow((Trackers[6].x - Trackers[5].x),2) + pow(abs(Trackers[6].y - Trackers[5].y),2));
   PupilDistanceBuffer[3] = PupilDistanceBuffer[2];
   PupilDistanceBuffer[2] = PupilDistanceBuffer[1];
   PupilDistanceBuffer[1] = PupilDistanceBuffer[0];
   PupilDistanceBuffer[0] = ActualDistance;
   }
   if(CycleDetected > 8)
   {
   AverageDistance = ((PupilDistanceBuffer[0]+PupilDistanceBuffer[1]+PupilDistanceBuffer[2]+PupilDistanceBuffer[3])/4);
   x = ActualDistance;
   y = AverageDistance;

   if(x>y){swap(x,y);}
   ratio  = x/y;
   if(ratio > 0.8)
   {
   PupilDistance = ActualDistance;
   }
   }
}




Mat ThreadWorker::GetHistogram(Mat src)
{




// set histogram bins count
int bins = 32;
int HistSize[]= {bins};
// set ranges for histogram bins
float lranges[]={0,256};
const float* ranges[]={lranges};
// create matrix for histogram
cv::Mat hist;
int channels[]={0};



/*
// create matrix for histogram visualization
  int const hist_height = 256;
  cv::Mat3b hist_image = cv::Mat3b::zeros(hist_height, bins);
*/

  cv::calcHist(&src, 1, channels, cv::Mat(), hist, 1, HistSize, ranges, true, false);
  double max_val=0;
  minMaxLoc(hist, 0, &max_val);
/*
  // visualize each bin
     for(int b = 0; b < bins; b++) {
         float const binVal = hist.at<float>(b);
         int   const height = cvRound(binVal*hist_height/max_val);
         cv::line
             ( hist_image
             , cv::Point(b, hist_height-height), cv::Point(b, hist_height)
             , cv::Scalar::all(255)
             );
     }

*/





return hist;
}


double ThreadWorker::CompareHistograms(Mat Hist1,Mat Hist2)
{
return  compareHist(Hist1,Hist2,CV_COMP_CORREL);
}


double ThreadWorker::GetPointDistance(Point x,Point y)
{
return sqrt(pow((x.x - y.x),2) + pow((x.y - y.y),2));
}




