#include "threadworker.h"



/////////////////////////////////////////////////////////
void ThreadWorker::MouthTracker()
{
Mat Mouth,MouthArea;
Point RoiPosition = RoiPoints[6];
Point MouthTrackers[4];
double minvalue,maxvalue;


Mat src = RoiMouth;
Mat gray;
cvtColor(src,gray,CV_BGR2GRAY);
vector<Mat> channels;
split(src,channels);

Mat MouthMask = Mat::zeros(gray.rows,gray.cols,gray.type());
Mat MouthMask02 = Mat::zeros(gray.rows,gray.cols,gray.type());

Point MiddlePoint;
MiddlePoint.x = gray.cols/2;
MiddlePoint.y = gray.rows/2;

cv::circle(MouthMask,MiddlePoint,(gray.cols/2), CV_RGB(255,255,255),-1);
cv::circle(MouthMask02,MiddlePoint,(gray.cols/3), CV_RGB(255,255,255),-1);

bitwise_and(MouthMask,gray,gray,noArray());





Mat a = Mat::zeros(gray.rows,gray.cols,CV_8UC1);
Mat g = Mat::zeros(gray.rows,gray.cols,CV_8UC1);
Mat f = Mat::zeros(gray.rows,gray.cols,CV_8UC1);
Mat v = Mat::zeros(gray.rows,gray.cols,CV_8UC1);

/////////////////////////I DETECTION////////////////////////////////////
Mat r;
gray.copyTo(r);

for(int i=0;i<src.rows;i++)
{
for(int j=0;j<src.cols;j++)
{
float bf =(channels[0].at<uchar>(i,j));
float gf =(channels[1].at<uchar>(i,j));
float rf =(channels[2].at<uchar>(i,j));
float sumf = bf+gf+rf;
g.at<uchar>(i,j) = (uchar)((gf/sumf) * 255);

r.at<uchar>(i,j) = (((LipsG*channels[1].at<uchar>(i,j))-channels[2].at<uchar>(i,j)-(LipsB*channels[0].at<uchar>(i,j)))/4);
}
}
/////////////////////// R /////////////////////////
GaussianBlur(r,r,Size(3,3),0,0,BORDER_DEFAULT);
cv::threshold(r,r,48,255,cv::THRESH_BINARY);


////////////////////////G/////////////////////
GaussianBlur(g,g,Size(9,9),0,0,BORDER_DEFAULT);
a =~g;
f =~g;
equalizeHist(a,a);
cv::threshold(a,a,255-32,255,cv::THRESH_BINARY);
//////////////////////////////////////////////




//////////////////////////////SOBEL 1.0///////////////////////////////////////////////
Mat gradient;
Sobel(f,gradient, CV_32F, 0, 1,CV_SCHARR);
convertScaleAbs(gradient,f);
blur(f,f,Size(3,3),Point(-1,-1),BORDER_DEFAULT);
equalizeHist(f,f);
cv::threshold(f,f,255-16,255,cv::THRESH_BINARY);
///////////////////////////////////////////////////////////////////////////////////////
bitwise_and(f,a,v);
//////////////////////////////////////GET ALL POINTS FROM V///////////////////////////


Mat Mask = r;



// Find all contours
std::vector<std::vector<cv::Point> > contours;
vector<Vec4i> hierarchy;
/// Find contours
findContours( Mask.clone(), contours, hierarchy, CV_RETR_EXTERNAL, CV_CHAIN_APPROX_SIMPLE,Point(1,1) );

double areaMax = 0;
double radiusMax = 0;
int CountOfDetections = contours.size();
int NumberOfMatches = 0;


// Fill holes in each contour
drawContours(Mask, contours, -1, CV_RGB(255,255,255), -1);

// Find the convex hull object for each contour
vector<vector<Point> >hull(CountOfDetections);

for (int i = 0; i <(CountOfDetections); i++) // sort the contours
{
    convexHull( Mat(contours[i]), hull[i],false );
}




for (int j = 0; j <(CountOfDetections-1); j++) // sort the contours
{
for (int i = 0; i <(CountOfDetections-1); i++)
{
    if( cv::contourArea(contours[i+1]) >  cv::contourArea(contours[i])){swap(contours[i],contours[i+1]);}
}
}


for (int i = 1; i <(CountOfDetections); i++) // sort the contours
{
    if(cv::contourArea(contours[i])<(cv::contourArea(contours[i]))/3)
    {
        drawContours(Mask,contours,i,CV_RGB(0,0,0),CV_FILLED,8,noArray(),0,Point(-1,-1));
    }

}



convexHull( Mat(contours[0]), hull[0],false );
drawContours(Mask, hull, -1, CV_RGB(255,255,255), -1);
drawContours(Frame_Trackers, hull, -1, CV_RGB(255,0,0), 2,8,noArray(),0,RoiPosition);





for (int i = 0; i < CountOfDetections; i++)
{
double area = cv::contourArea(contours[i]);    // Blob area
cv::Rect rect = cv::boundingRect(contours[i]); // Bounding box around the shape
int radius = rect.width/2;                     // Approximate radius


Rect RectX = rect;

RectX.y = rect.y - rect.height;
RectX.height = RectX.height * 2;


    NumberOfMatches++;
    if(area>areaMax){areaMax = area;}
    if(radius>radiusMax){radiusMax = radius;}

}






for (int i = 0; i < CountOfDetections; i++)
{
double area = cv::contourArea(contours[i]);    // Blob area
cv::Rect rect = cv::boundingRect(contours[i]); // Bounding box around the shape
int radius = rect.width/2;                     // Approximate radius


 //According to the shape proportions can we assume whitch shape is the right one
if (area == areaMax && radius == radiusMax && NumberOfMatches > 0)
      {
      cv::Rect LeftRow;
      cv::Rect RightRow;

      LeftRow.x = rect.x;
      LeftRow.y = rect.y;
      LeftRow.width = 4;
      LeftRow.height = rect.height;

      RightRow.x = rect.x+ rect.width - 4;
      RightRow.y = rect.y;
      RightRow.width = 4;
      RightRow.height = rect.height;


    for(int i=1; i<=2;i++)
     {

        if(i==1){Mask(LeftRow).copyTo(MouthArea);}
        else{Mask(RightRow).copyTo(MouthArea);}

         // Find all contours
         std::vector<std::vector<cv::Point> > contours02;
         vector<Vec4i> hierarchy02;
         /// Find contours
         findContours( MouthArea.clone(), contours02, hierarchy02, CV_RETR_EXTERNAL, CV_CHAIN_APPROX_SIMPLE,Point(1,1) );

         // Fill holes in each contour
         drawContours(MouthArea, contours02, -1, CV_RGB(255,255,255), -1);
         int CountOfDetections02 = contours02.size();
         Point Detections[CountOfDetections02];

        for (int j = 0; j < CountOfDetections02; j++)
         {
             cv::Rect rect02 = cv::boundingRect(contours02[j]); // Bounding box around the shape
             Detections[j].x = rect02.x +( rect02.width/2);
             Detections[j].y = rect02.y +( rect02.height/2);
         }



        for (int k = 0; k <(CountOfDetections02-1); k++) // Y - vertical ascending sorting algorithm
        {
        for (int l = 0; l <(CountOfDetections02-1); l++)
        {

            if( Detections[l+1].y >  Detections[l].y){swap(Detections[l],Detections[l+1]);}

        }
        }

        if(i==1){MouthTrackers[0] = Detections[0] + Point(LeftRow.x,LeftRow.y);}
        else{MouthTrackers[1] = Detections[0] + Point(RightRow.x,RightRow.y);}

}

             MouthTrackers[2].x = rect.x + (rect.width/2);
             MouthTrackers[2].y = rect.y;

             MouthTrackers[3].x = rect.x + (rect.width/2);
             MouthTrackers[3].y = rect.y + rect.height;

      }

}

////////////////////////// CHECK //////////////////////////////
Point L = MouthTrackers[0];
Point U = MouthTrackers[2];
Point D = MouthTrackers[3];
Point R = MouthTrackers[1];

uint sum = 0;
if(L.x < U.x && L.x < D.x && L.x < R.x)
{sum+=1;}
if(R.x > U.x && R.x > D.x && R.x > L.x)
{sum+=1;}
if(U.y < L.y && U.y < R.y && U.y < D.y)
{sum+=1; }
if(D.y > L.y && D.y > R.y && D.y > U.y)
{sum+=1;}








if(sum >= 4)
{
Trackers[9]  = L +RoiPosition;
Trackers[10]  = U +RoiPosition;
Trackers[11] = R +RoiPosition;
Trackers[12] = D +RoiPosition;
}



}

