#include "threadworker.h"

void ThreadWorker::RoiDetection()
{


vector<Rect> faces;
Mat GrayFrame;





cvtColor(Frame,GrayFrame,CV_BGR2GRAY);  // make the Gray version of frame1x
equalizeHist(GrayFrame,GrayFrame);


// now we have to detect face

face_cascade.detectMultiScale(GrayFrame,faces,1.1,2,0|CV_HAAR_SCALE_IMAGE,Size(250,250));

uint NumberOfFaces = faces.size();

if(NumberOfFaces>0)
{
Face PotentialFace[NumberOfFaces];
Face FaceSel;

for (int i = 0; i < NumberOfFaces; i++)
{
PotentialFace[i].SetPos(Point(faces[i].x,faces[i].y));
PotentialFace[i].SetSize(faces[i].width,faces[i].height);
}

if(NumberOfFaces > 1) // sort the faces due to their size
{
for (int j = 0; j <(NumberOfFaces-1); j++) // size ascending sorting algorithm
{
for (int i = 0; i <(NumberOfFaces-1); i++)
{
    if( PotentialFace[i+1].size > PotentialFace[i].size){swap(PotentialFace[i],PotentialFace[i+1]);}
}
}
}


FaceSel = PotentialFace[0];

Face_Detected = true;
FalseDetections = 0;
for (int i = 0; i < NumberOfFaces; i++)
{


if(!FaceSelMem[0].pos.x) // smooth the faces
{
FaceSelMem[5] = FaceSel;
FaceSelMem[4] = FaceSel;
FaceSelMem[3] = FaceSel;
FaceSelMem[2] = FaceSel;
FaceSelMem[1] = FaceSel;
FaceSelMem[0] = FaceSel;
}
else
{
FaceSelMem[5] = FaceSelMem[4];
FaceSelMem[4] = FaceSelMem[3];
FaceSelMem[3] = FaceSelMem[2];
FaceSelMem[2] = FaceSelMem[1];
FaceSelMem[1] = FaceSelMem[0];
FaceSelMem[0] = FaceSel;


double X =0;
double Y =0;
double W =0;
double H =0;

for(int j=0; j<6;j++)
{
X += FaceSelMem[j].pos.x /6;
Y += FaceSelMem[j].pos.y /6;
W += FaceSelMem[j].width /6;
H += FaceSelMem[j].height /6;
}
FaceSel.width = W;
FaceSel.height =H;
FaceSel.pos.x = X;
FaceSel.pos.y = Y;
}

Point LeftUp(FaceSel.pos.x, FaceSel.pos.y);
Point RightDown((FaceSel.pos.x+FaceSel.width),(FaceSel.pos.y+FaceSel.height));

Point RightDownEyes((FaceSel.pos.x+(FaceSel.width*0.85)),(FaceSel.pos.y+(FaceSel.height/2)));
Point LeftUpEyes(FaceSel.pos.x+(FaceSel.width*0.15), FaceSel.pos.y+FaceSel.height/6.5);

Point LeftUpMouth((LeftUpEyes.x),(RightDownEyes.y));
Point RightDownMouth((RightDownEyes.x),(FaceSel.pos.y+(FaceSel.height*1.15)));
if(RightDownMouth.y > Frame.rows){RightDownMouth.y = Frame.rows;}

int width = RightDownEyes.x - LeftUpEyes.x;

Point LeftDownEyes(LeftUpEyes.x+(width/2.2),RightDownEyes.y);
Point RightUpEyes(RightDownEyes.x-(width/2.2),LeftUpEyes.y);
Rect ROI_L_Eye(LeftUpEyes,Point(LeftUpEyes.x+(width/2.2),RightDownEyes.y));
Rect ROI_R_Eye(Point(RightDownEyes.x-(width/2.2),LeftUpEyes.y),RightDownEyes);
Rect ROI_EYES(LeftUpEyes,RightDownEyes);

Rect ROI_Mouth(LeftUpMouth,RightDownMouth);

ROI_L_Eye_Position.x =ROI_L_Eye.x; // Set the ROI position for both eyes
ROI_L_Eye_Position.y =ROI_L_Eye.y;
ROI_R_Eye_Position.x =ROI_R_Eye.x;
ROI_R_Eye_Position.y =ROI_R_Eye.y;




Frame(ROI_L_Eye).copyTo(RoiEyeLeft);
Frame(ROI_R_Eye).copyTo(RoiEyeRight);
Frame(ROI_Mouth).copyTo(RoiMouth);


ColorMask(ROI_EYES).copyTo(RoiEyesMask);
ColorMask(ROI_Mouth).copyTo(RoiMouthMask);


RoiPoints[0] = LeftUp;
RoiPoints[1] = RightDown;
RoiPoints[2] = LeftUpEyes;
RoiPoints[3] = LeftDownEyes;
RoiPoints[4] = RightUpEyes;
RoiPoints[5] = RightDownEyes;
RoiPoints[6] = LeftUpMouth;
RoiPoints[7] = RightDownMouth;

Trackers[0].x = (LeftUp.x + RightDown.x) /2;
Trackers[0].y = (LeftUp.y + RightDown.y) /2;




}
}
else
{
Face_Detected = false;
FalseDetections ++;
}






}
