#ifndef T_USER_CLASSES_H
#define T_USER_CLASSES_H

#endif // T_USER_CLASSES_H

#include "threadworker.h"
using namespace cv;
using namespace std;

class ColorPoint
{
public:
Point pos;
double ratio;
Rect rec;
double area;
ColorPoint()
{}

void SetRec(Rect r)
{
rec = r;

pos.x = rec.x + (rec.width/2);
pos.y = rec.y + (rec.height/2);
int x = rec.width;
int y = rec.height;
if(x>y){swap(x,y);}
ratio = x/y;
}
void SetArea(double a)
{
area = a;
}
};



class MouthPoint
{
public:
Point pos;
double distance;
MouthPoint()
{
distance = 0;
}
void SetPos(Point p)
{
pos = p;
}

void SetDist(double dis,double count)
{
distance += (dis/count);
}

};


class Face
{
public:
Point pos;
uint width;
uint height;
uint size;
Face()
{
}

void SetPos(Point po)
{
pos = po;
}

void SetSize(uint wid,uint hei)
{
width = wid;
height = hei;
size = wid*hei;
}

};



class Blob
{
public:
Point pos;
double area;
Rect rect;
Blob()
{

}


void SetSize(double ar)
{
area = ar;
}

void SetRect(Rect rec)
{
rect = rec;
pos.x = rect.x + (rect.width/2);
pos.y = rect.y + (rect.height/2);
}

};




class EyeBrowPoint
{
public:
Point pos;
Point tpos;


EyeBrowPoint()
{
}

void SetPos(Point p)
{
pos = p;
}

void SetTPos(Point p)
{
tpos = p;
}

};



class EyeBrow
{
public:
double area;
Rect rect;
Point position;
double ratio;
double thinness;
double distance;
uint rate;
vector<Point> contours;

EyeBrow()
{
rate = 0;
}

void SetArea(double are)
{
area = are;
}

void SetContours(vector<Point> con)
{
contours = con;
}

void SetRect(Rect rec)
{
rect = rec;
ratio = ((1 - (area/(rect.height * rect.width)))*area) ;
}

void SetPos(Point pos)
{
position = pos;
}

void SetRate(uint rat)
{
rate = rat;
}
void SetDistance(double dist)
{
distance = dist;
}


};






class Pupil
{
public:
double ratio;
double distance;
double area;
Rect rect;
Point lastposition;
Point position;
int rate;


Pupil()
{
rate = 0;
}

public:

void SetArea(double are)
{
area = are;
}

void SetPositionAndRatio(Rect rect)
{
position.x = rect.x  + (rect.width/2);
position.y = rect.y  + (rect.height/2);
double x = rect.width;
double y = rect.height;
if(x>y){swap(x,y);}
ratio = x/y;
}

void SetDistance(Point lastposition)
{
int xdist = abs(lastposition.x - position.x);
int ydist = abs(lastposition.y - position.y);
distance = sqrt(pow(xdist,2) + pow(ydist,2));
}


Point GetPosition()
{
return position;
}


};
