#include "threadworker.h"


void ThreadWorker::EyeBrowDetector(Rect LRoi, Rect RRoi, Point LeftMarker, Point RightMarker, Point LeftCorner, Point RightCorner)
{

LeftMarker.y +=6;
RightMarker.y +=6;
Mat src,gray,RoiLeft,RoiRight;
Point corner;
Point Marker;
Point FinalPoints[6];
Point EdgePoints[3];
uint BlurSize =EbBlur2;



Frame(LRoi).copyTo(RoiLeft);
Frame(RRoi).copyTo(RoiRight);

for(int eyebrow = 1; eyebrow<=2 ;eyebrow ++)   ///////// Calculate for both eyebrows
{
if(eyebrow == 1){src = RoiLeft; corner = LeftCorner; Marker = LeftMarker;}
else{src = RoiRight; corner = RightCorner; Marker = RightMarker;}

cv::cvtColor(~src,gray,CV_BGR2GRAY);

GaussianBlur(gray,gray,Size(BlurSize,BlurSize),0,0,BORDER_DEFAULT);

//////////////////////////////SOBEL 1.0///////////////////////////////////////////////
Mat gradient;
Sobel(gray,gradient, CV_32F, 0, 1,CV_SCHARR);
gradient.convertTo(gray, CV_8U,0.5,128);
/////////////////////////////////////////////////////////////////////////////////////////

GaussianBlur(gray,gray,Size(21,21),0,0,BORDER_DEFAULT);

//////////////////////////////SOBEL 2.0///////////////////////////////////////////////

Sobel(gray,gradient, CV_32F, 0, 1,CV_SCHARR);
gradient.convertTo(gray, CV_8U,0.5,128);
/////////////////////////////////////////////////////////////////////////////////////////


double minvalue,maxvalue;

cv::minMaxIdx(gray,&minvalue,&maxvalue,0,0,noArray());
gray=~gray;
cv::threshold(gray,gray,maxvalue - (maxvalue*0.2), 255, cv::THRESH_BINARY);


/////////////////////////////////////////////////////////////////////////////
std::vector<std::vector<cv::Point> > contours;
findContours(gray.clone(), contours, CV_RETR_EXTERNAL, CV_CHAIN_APPROX_SIMPLE);

uint CountOfDetections = (uint)contours.size();

// Fill holes in each contour
drawContours(gray, contours, -1, CV_RGB(255,255,255), -1);
GaussianBlur(gray,gray,Size(3,3),0,0,BORDER_DEFAULT);

EyeBrow EyeBrowCandidates[CountOfDetections];





if(CountOfDetections > 0)
{
for (int i = 0; i < contours.size(); i++)
{
EyeBrowCandidates[i].SetArea(cv::contourArea(contours[i]));
Rect rect = cv::boundingRect(contours[i]);
EyeBrowCandidates[i].SetRect(rect); // Bounding box around the shape
EyeBrowCandidates[i].SetPos(Point((rect.x + (rect.width/2)),(rect.y+(rect.height/2))));


double distance = GetPointDistance(EyeBrowCandidates[i].position,Marker);

EyeBrowCandidates[i].SetDistance(distance);
}
////////////////////////////// SORT THE CANDIDATES ///////////////////////////////////////////


for (int j = 0; j <(CountOfDetections-1); j++) // distance descending sorting algorithm
{
for (int i = 0; i <(CountOfDetections-1); i++)
{
    if( EyeBrowCandidates[i+1].distance <  EyeBrowCandidates[i].distance){swap(contours[i],contours[i+1]);  swap(EyeBrowCandidates[i],EyeBrowCandidates[i+1]);}
}
}

/////////////////////////////////////////////////////////////////////////////////////////////


Rect UpArea = EyeBrowCandidates[0].rect;
UpArea.height *=0.5;

//////////////////////////////////////////FIND CONVEX HULL///////////////////////////////////////////////////


vector<vector<Point> >hull(1);
convexHull( Mat(contours[0]), hull[0], false );

if(eyebrow == 1)
{drawContours(Frame_Trackers,contours, 0,Scalar(255,100,0), 2, 8, vector<Vec4i>(), 0, corner );}
else{drawContours(Frame_Trackers,contours, 0,Scalar(0,100,255), 2,8, vector<Vec4i>(), 0, corner );}

uint size = hull[0].size();


Point Points[size];
Point RotPoints[size];
EyeBrowPoint xPoints[size];


for(int i=0;i<size;i++) // get the all points
{
 Points[i] = hull[0][i];
}

////////////////////////////////////////////// SORT THE POINTS ///////////////////////////////////


for (int j = 0; j <(size-1); j++) // x sorting
{
for (int i = 0; i <(size-1); i++)
{
    if( Points[i+1].x <  Points[i].x){swap(Points[i],Points[i+1]);}
}
}
EdgePoints[0] = Points[0];





for (int j = 0; j <(size-1); j++) // x sorting
{
for (int i = 0; i <(size-1); i++)
{
    if( Points[i+1].x >  Points[i].x){swap(Points[i],Points[i+1]);}
}
}
EdgePoints[2] = Points[0];

///////////////////////////////////////////FIND THE BREAK AREA/////////////////////////////////////////////


for (int j = 0; j <(size-1); j++) // y sorting
{
for (int i = 0; i <(size-1); i++)
{
    if( Points[i+1].y <  Points[i].y){swap(Points[i],Points[i+1]);}
}
}




EdgePoints[1] = Points[0];
uint U = 1;
for(int i=1;i<size/2;i++)
{
    if (IsPointInsideRect(Points[i],UpArea))
    {
      EdgePoints[1] += Points[0];
      U++;
    }
}



EdgePoints[1].y /=U;
if(eyebrow == 1)
{
EdgePoints[1].x = EdgePoints[0].x + (abs(EdgePoints[2].x - EdgePoints[0].x)*0.333);
}
else
{
EdgePoints[1].x = EdgePoints[0].x + (abs(EdgePoints[2].x - EdgePoints[0].x)*0.666);
}
//////////////////////////////////////////////////////////////////////////////////////////////////

if(eyebrow == 1)
{
FinalPoints[0] = EdgePoints[0]+ corner;
FinalPoints[1] = EdgePoints[1]+ corner;
FinalPoints[2] = EdgePoints[2]+ corner;
}
else
{
FinalPoints[3] = EdgePoints[0]+ corner;
FinalPoints[4] = EdgePoints[1]+ corner;
FinalPoints[5] = EdgePoints[2]+ corner;
}

}



} // end of loop

bool check = true;

if(check == true) // write the points to the trackers
{
    for(int i=0;i<6;i++)
    {
        Trackers[i+1] = FinalPoints[i];
    }

}


}

