#include "threadworker.h"


void ThreadWorker::EyeBrowTrackerRun()
{

   // qDebug()<<EbBlur1;
   // qDebug()<<EbBlur2;
   // qDebug()<<EbAccurateMode;


bool run = false;
bool write = true;
uint BlurSize =EbBlur1;
double part = 0.2;

Point DetectedPoint;
Mat src,gray;
uint LPupilHeight,RPupilHeight;
Mat RoiEyeBrowLeft;
Mat RoiEyeBrowRight;

LPupilHeight =(Trackers[7].y - RoiPoints[2].y)*0.88;
RPupilHeight =(Trackers[8].y - RoiPoints[4].y)*0.88;


Point LCorner(RoiPoints[2].x,RoiPoints[2].y);
Point RCorner(RoiPoints[4].x,RoiPoints[4].y);

Rect EYEBROW_L(LCorner,RoiPoints[3]);
Rect EYEBROW_R(RCorner,RoiPoints[5]);

EYEBROW_L.height = LPupilHeight;
EYEBROW_R.height = RPupilHeight;

Frame(EYEBROW_L).copyTo(RoiEyeBrowLeft);
Frame(EYEBROW_R).copyTo(RoiEyeBrowRight);



//rectangle(Frame_Trackers,EYEBROW_L, CV_RGB(255,255,255));
//rectangle(Frame_Trackers,EYEBROW_R, CV_RGB(255,255,255));


Point Blob1,Blob2,Blob3,Blob4;



if(CycleDetected>8){run = true;}

if(run == true) ////////////RUN THE EYEBROW TRACKING///////////////////////////////
{




for(int eyebrow = 1; eyebrow<=2 ;eyebrow ++)   ///////// Calculate for both eyebrows
{
if(eyebrow == 1){src = RoiEyeBrowLeft;}
else{src = RoiEyeBrowRight;}



cv::cvtColor(~src,gray,CV_BGR2GRAY);
GaussianBlur(gray,gray,Size(BlurSize,BlurSize),0,0,BORDER_DEFAULT);

Mat mask = Mat::zeros(gray.rows,gray.cols,CV_8UC1);
if(eyebrow == 1)
{circle(mask,Point(gray.cols/1.5,gray.rows),gray.cols/1.5,Scalar(255,255,255),-1);}
else
{circle(mask,Point(gray.cols/3,gray.rows),gray.cols/1.5,Scalar(255,255,255),-1);}




/////////////////////SOBEL////////////////////////

int delta = 0;
int ddepth = CV_16S;
int scale = 1;

Mat  grad_y;

/// Gradient Y
Sobel( gray, grad_y, ddepth, 0, 1, CV_SCHARR, scale, delta, BORDER_DEFAULT );
convertScaleAbs( grad_y, gray );

/////////////////////////////////////////////////

//equalizeHist(gray,gray);

double minvalue;
double maxvalue;
cv::minMaxIdx(gray,&minvalue,&maxvalue,0,0,noArray());


cv::threshold(gray,gray,maxvalue-((maxvalue-minvalue)/4), 255, cv::THRESH_BINARY);

bitwise_and(mask,gray,gray);


std::vector<std::vector<cv::Point> > contours;
findContours(gray.clone(), contours, CV_RETR_EXTERNAL, CV_CHAIN_APPROX_NONE);

uint CountOfDetections = (uint)contours.size();

// Fill holes in each contour
drawContours(gray, contours, -1, CV_RGB(255,255,255), -1);
GaussianBlur(gray,gray,Size(3,3),0,0,BORDER_DEFAULT);

EyeBrow EyeBrowCandidates[CountOfDetections];

if(CountOfDetections > 0)
{
for (int i = 0; i < contours.size(); i++)
{
EyeBrowCandidates[i].SetArea(cv::contourArea(contours[i]));
Rect rect = cv::boundingRect(contours[i]);
EyeBrowCandidates[i].SetRect(rect); // Bounding box around the shape
EyeBrowCandidates[i].SetPos(Point((rect.x + (rect.width/2)),(rect.y+(rect.height/2))));



}





if(CountOfDetections > 1) /// sort the candidates ///////////////////////////////CHART////////////////////////////////////
{

    /*
    for (int j = 0; j <(CountOfDetections-1); j++) // distance descending sorting algorithm
    {
    for (int i = 0; i <(CountOfDetections-1); i++)
    {
        if( EyeBrowCandidates[i+1].distance <  EyeBrowCandidates[i].distance){swap(EyeBrowCandidates[i],EyeBrowCandidates[i+1]);}
    }
    }
    EyeBrowCandidates[0].rate += 0;
*/


    for (int j = 0; j <(CountOfDetections-1); j++) // Y-pos descending sorting algorithm
    {
    for (int i = 0; i <(CountOfDetections-1); i++)
    {
        if( EyeBrowCandidates[i+1].position.y >  EyeBrowCandidates[i].position.y){swap(EyeBrowCandidates[i],EyeBrowCandidates[i+1]);}
    }
    }
    EyeBrowCandidates[0].rate += 0;




    for (int j = 0; j <(CountOfDetections-1); j++) // area descending sorting algorithm
    {
    for (int i = 0; i <(CountOfDetections-1); i++)
    {
        if( EyeBrowCandidates[i+1].area >  EyeBrowCandidates[i].area){swap(EyeBrowCandidates[i],EyeBrowCandidates[i+1]);}
    }
    }
    EyeBrowCandidates[0].rate += 1;


    for (int j = 0; j <(CountOfDetections-1); j++) // ratio descending sorting algorithm
    {
    for (int i = 0; i <(CountOfDetections-1); i++)
    {
        if( EyeBrowCandidates[i+1].ratio >  EyeBrowCandidates[i].ratio){swap(EyeBrowCandidates[i],EyeBrowCandidates[i+1]);}
    }
    }
    EyeBrowCandidates[0].rate += 0;



    for (int j = 0; j <(CountOfDetections-1); j++) // rate descending sorting algorithm
    {
    for (int i = 0; i <(CountOfDetections-1); i++)
    {
        if( EyeBrowCandidates[i+1].rate >  EyeBrowCandidates[i].rate){swap(EyeBrowCandidates[i],EyeBrowCandidates[i+1]);}
    }
    }





}


//////////////////////////SET THE SMALL ROIS/////////////////////////////////////
DetectedPoint = EyeBrowCandidates[0].position;
Rect OutRect = EyeBrowCandidates[0].rect;



uint shift = OutRect.width*part;
Rect LeftArea = OutRect;
Rect RightArea = OutRect;
LeftArea.width = shift;
RightArea.width = shift;
RightArea.x += (OutRect.width - shift);
Mat Roi[2];
Point Blobs[2];

if(LeftArea.width > 2 && LeftArea.height>2 && RightArea.width > 2 && RightArea.height> 2)
{
gray(LeftArea).copyTo(Roi[0]);
gray(RightArea).copyTo(Roi[1]);
Point SCorners[2];
SCorners[0]=Point(LeftArea.x,LeftArea.y);
SCorners[1]=Point(RightArea.x,RightArea.y);

for (int k = 0; k <= 1; k++)
{

std::vector<std::vector<cv::Point> > contours2;
findContours(Roi[k].clone(), contours2, CV_RETR_EXTERNAL, CV_CHAIN_APPROX_NONE);
uint CountOfDetections2 = (uint)contours2.size();
drawContours(Roi[k], contours2, -1, CV_RGB(255,255,255), -1); // Fill holes in each contour
EyeBrow Candidates[CountOfDetections2];


if(CountOfDetections2>0)
{
for (int iq = 0; iq < contours2.size(); iq++)
{

Candidates[iq].SetArea(cv::contourArea(contours2[iq]));
Rect rect2 = cv::boundingRect(contours2[iq]);
Candidates[iq].SetRect(rect2); // Bounding box around the shape
Candidates[iq].SetPos(Point((rect2.x + (rect2.width/2)),(rect2.y+(rect2.height/2))));
}


if(CountOfDetections2>1)
{


for (int jx = 0; jx <(CountOfDetections2-1); jx++) // X-pos descending sorting algorithm
{
for (int ix = 0; ix <(CountOfDetections2-1); ix++)
{
    if( Candidates[ix+1].area>  Candidates[ix].area){swap(Candidates[ix],Candidates[ix+1]);}
}
}

}

Blobs[k] = Candidates[0].position + SCorners[k];

}
else
{
write = false;
}


} // end of small for //////////////////////////////////////////////////////////////////
}





if(write == true)
{
if(eyebrow == 1)
{
Blob1 = Blobs[0] +LCorner;
Blob2 = Blobs[1] +LCorner;
}
else
{
Blob3 = Blobs[0] +RCorner;
Blob4 = Blobs[1] +RCorner;
}
}



}
} // end of for

} // end of run = true






if(run == true && write == true)
{

/////////////////////////CHECK /////////////////////////////

bool finalwrite = true;

uint check =0; // check 01

Point LU(EYEBROW_L.x,EYEBROW_L.y);
Point LD((EYEBROW_L.x)+(EYEBROW_L.width),(EYEBROW_L.y)+(EYEBROW_L.height));
Point RU(EYEBROW_R.x,EYEBROW_R.y);
Point RD((EYEBROW_R.x)+(EYEBROW_R.width),(EYEBROW_R.y)+(EYEBROW_R.height));

check += IsPointInsideRoi(Blob1,LU,LD);
check += IsPointInsideRoi(Blob2,LU,LD);
check += IsPointInsideRoi(Blob3,RU,RD);
check += IsPointInsideRoi(Blob4,RU,RD);
if(check != 4){finalwrite = false;}


if(Blob1.x > Blob2.x || Blob3.x > Blob4.x){finalwrite = false;} // check 02

double x =abs(Blob2.x - Blob1.x);
double y =abs(Blob4.x - Blob3.x);
if(x>y){swap(x,y);}
if((x/y)<0.5){finalwrite = false;} // check 03

if(Trackers[7].y <= Blob1.y || Trackers[7].y <= Blob2.y){finalwrite = false;} // check 04
if(Trackers[8].y <= Blob3.y || Trackers[7].y <= Blob4.y){finalwrite = false;}


if(finalwrite == true)
{
 EyeBrowDetector(EYEBROW_L,EYEBROW_R,Blob1-LCorner,Blob4-RCorner,LCorner,RCorner);
}


}





}



