#ifndef THREADWORKER_H
#define THREADWORKER_H

#include <QObject>
#include <QDebug>
#include <QThread>
#include <QString>
#include <QTcpSocket>
#include <QVector2D>





////////////c++////////////
#include <iostream>
#include <stdio.h>
#include <algorithm>
#include <WinSock2.h>
#include <Windows.h>


////////open cv ///////////
#include "opencv/cv.h"
#include "opencv/highgui.h"
#include "opencv2/objdetect/objdetect.hpp"
#include "opencv2/highgui/highgui.hpp"
#include "opencv2/imgproc/imgproc.hpp"


#include "myserver.h"
#include "T_User_Classes.h"

#define PI 3.14159265

using namespace cv;
using namespace std;

class ThreadWorker : public QObject
{
    Q_OBJECT
public:
    explicit ThreadWorker(QObject *parent = 0);

///////////////////variables////////////////
private:


bool ColorTrack;
Mat RawFrame;
Mat FinalFrame;
Mat FinalRoi;
Mat * DestinationImagePointer;
QString * DestinationDataPointer;
Mat * RoiImagePointer;
Mat   SampleImage;
String face_cascade_name;


CascadeClassifier face_cascade;


RNG rng; // random number generator
Point center;



double CycleDetected;
Mat Frame;
Mat Frame_Trackers;
Mat ColorMask;
Mat TestFrame;
Mat Frame_FixedTrackers;

Point AverageLeftPupilPosition;
Point AverageRightPupilPosition;

Point PupilPositionBufferR[4];
Point PupilPositionBufferL[4];





double PupilDistanceBuffer[4];
double PupilDistance;

Point ActualPositionL;
Point ActualPositionR;
Point LEyeLastPos;
Point REyeLastPos;


float LipsG;
float LipsB;


Mat RoiEyeLeft;
Mat RoiEyeRight;
Mat RoiEyesMask;
Mat RoiEyeLeftMask;
Mat RoiEyeRightMask;
Mat RoiMouth;
Mat RoiMouthMask;

Point2f RoiPoints[16];
Point2f Trackers[13];
Point2f aTrackers[13];
Point2f dTrackers[13];
Point2f fTrackers[13];
double TrackingPointsMemX[13][8];
double TrackingPointsMemY[13][3];
Point2f sTrackers[13];
Point rTrackers[13];
Face FaceSelMem[6];
double AngleMem[3];


Point MousePosition;
Point ROI_L_Eye_Position;
Point ROI_R_Eye_Position;
Point L_Pupil_Position;
Point R_Pupil_Position;
bool Face_Detected;
Point GazeMemory[16];
Point EyesMiddlePointMem[4];
Point FastPointMem[4];
Point Base;
double GazeSmoothMem[8];
double AngleSmoothMem[8];
Point PointSmoothMem[13][3];

cv::Point2f Point_R_MiddleFace;

uint H_value;
uint S_value;
uint V_value;
uint T_value;
uint R_value;
uint FaceRange;
uint TrackersRange;
uint ComboBoxIndex;

uint FalseDetections;
uint ColorCountHSV;
uint ColorCountMouth;

uint EyesAreaSize;
uint EyesDarkPoint;
uint EyesMaxMov;
uint EyesMinMov;
uint EyesBlur;
uint EyesDepth;
bool EyesFastTracking;

bool EbAccurateMode;
uint EbBlur1;
uint EbBlur2;


double MaxValueMemoryL[8];
double MaxValueMemoryR[8];

double DistanceMem[3];
double GazeDirection;
double HeadAngle;

bool Ldistance;
bool Rdistance;

Point EBPosMemoryL;
Point EBPosMemoryR;

Mat HistMemoryL;
Mat HistMemoryR;
uint HSV_Colors[5][6];


QString TrackingData;

/////////////////functions /////////////////

private:

void EyeTrackerRun();
void EyeBrowTrackerRun();
void RoiDetection();
void Drawer();
void CreateColorMask(Mat *RawFrame);
void MarkerTracker(Mat RoiMask, Point RoiPosition, uint ExpectedCount,QString Type);
void MarkerSelector();
void MouthTracker();
void MouthDetector();
bool IsPointInsideRoi(Point InspectedPoint, Point LP_Point, Point RD_Point);
bool IsPointInsideRect(Point InspectedPoint, Rect InspectedRect);
void DataProcessing();
void GetPupilDistance();
void EyeBrowShaper();
void EyeBrowDetector(Rect LRoi, Rect RRoi, Point LeftMarker,Point RightMarker, Point LeftCorner, Point RightCorner);
void GazeDetector();
void AlignTrackers();
void SmoothTrackers();
double GetPointDistance(Point x,Point y);
Mat  GetHistogram(Mat src);
Point RotatePoint(Point Pivot,Point PointToRotate,double AngleAlpha);


signals:


public slots:
void Start();
void MouseLeft(Point *MPosition);
void Get_HSV_Data(uint *H_v, uint *S_v, uint *V_v,uint *R_v);
void Get_LIPS_Data(float *G_value,float *B_value);
void Get_EYES_Data(uint * Pup,uint * Dark,uint * Max,uint * Min,uint * Blur,uint * Depth,bool *FastTrack);
void Get_EB_Data(uint * B1,uint * B2);
void Get_ComboBoxIndex(uint *In);
void Get_ColorIndex(uint * index);
void Get_TrackingMethod(bool * TrackMethod);
void Tracker(Mat *RawF);
void Initialize(Mat *DestinationImage,QString *DestinationData);
double CompareHistograms(Mat Hist1, Mat Hist2);




///////////////////////////////////////////
};

#endif // THREADWORKER_H
