
import c4d
import time 
import math
import socket
import signal 
from c4d import plugins
from c4d import documents
import os
from threading import Thread, Lock
from datetime import datetime


# Face Tracker 1.0 
# by Pixeton s.r.o. (www.pixeton.com)
# Author: Peter Kajan (info@pixeton.com)
# 14/04/2014

# Plugin IDs 1000001-1000010 are reserved for development
# Get yours at www.plugincafe.com
PLUGIN_ID = 1031922 

# ############################### Global IDs

UI_LNK_SKELETON = 10000  
UI_LNK_MESH = 10001

UI_BT_BIND = 10002
UI_BT_EDIT = 10003
UI_BT_LOAD= 10004
UI_BT_RUN= 10007
UI_CH_REC = 10008

UI_BT_SAVEFP =10009
UI_BT_LOADFP = 10010
UI_BT_DEFAULT = 10011

UI_CH_ABS= 10012
UI_BT_DEL = 10013

UI_EN_DOCFPS = 10014
UI_EN_REAFPS = 10015
UI_T_IP = 10005
UI_T_PORT = 10006

ID_BIND = 1019881
ID_ALIGN = 1019883
ID_PLAY = 12412
ID_DELETE = 12109

WEIGHT_TAG_ID = 1019365

# ##############################OTHER GLOBAL VARIABLES

VECTOR_01 = c4d.Vector()
VECTOR_02 = c4d.Vector()
VECTOR_03 = c4d.Vector()

TCP_IP_ADDRESS  = '127.0.0.1'
TCP_PORT = 1234
BUFFER_SIZE = 1024
PI = 3.14159265359

ID_POSITION_X=c4d.DescID(c4d.DescLevel(c4d.ID_BASEOBJECT_GLOBAL_POSITION,c4d.DTYPE_VECTOR,0),c4d.DescLevel(c4d.VECTOR_X,c4d.DTYPE_REAL,0))
ID_POSITION_Y=c4d.DescID(c4d.DescLevel(c4d.ID_BASEOBJECT_GLOBAL_POSITION,c4d.DTYPE_VECTOR,0),c4d.DescLevel(c4d.VECTOR_Y,c4d.DTYPE_REAL,0))
ID_POSITION_Z=c4d.DescID(c4d.DescLevel(c4d.ID_BASEOBJECT_GLOBAL_POSITION,c4d.DTYPE_VECTOR,0),c4d.DescLevel(c4d.VECTOR_Z,c4d.DTYPE_REAL,0))

PREPARE = 0


# #################################### REFRESH FUNCTION

def Refresh():
	

	ref =  False;
	cFrame = GetCurrentFrame()

	
	# read the user data and Plane size and Plane position
	FaceSkeleton = Helpers[0].Base
	Plane = Helpers[0].Plane
	PlaneSize = Plane[c4d.NULLOBJECT_RADIUS]
	PlaneSize = (math.sqrt((PlaneSize*PlaneSize)/2))*2

	
	# get  the user data 
	MouthPosAdd = FaceSkeleton[c4d.ID_USERDATA,3]
	MouthPosMult = FaceSkeleton[c4d.ID_USERDATA,2]
	LEyebrowPosAdd = FaceSkeleton[c4d.ID_USERDATA,5]
	LEyebrowPosMult = FaceSkeleton[c4d.ID_USERDATA,10]
	REyebrowPosAdd = FaceSkeleton[c4d.ID_USERDATA,8]
	REyebrowPosMult = FaceSkeleton[c4d.ID_USERDATA,11]
	
	
	
	# get the shift data
	Trackers[0].Shift = FaceSkeleton[c4d.ID_USERDATA,20]
	Trackers[1].Shift  = FaceSkeleton[c4d.ID_USERDATA,21]
	Trackers[2].Shift  = FaceSkeleton[c4d.ID_USERDATA,22]
	
	Trackers[3].Shift  = FaceSkeleton[c4d.ID_USERDATA,24]
	Trackers[4].Shift  = FaceSkeleton[c4d.ID_USERDATA,25]
	Trackers[5].Shift  = FaceSkeleton[c4d.ID_USERDATA,26]
	
	Trackers[6].Shift  = FaceSkeleton[c4d.ID_USERDATA,14]
	Trackers[7].Shift  = FaceSkeleton[c4d.ID_USERDATA,15]
	Trackers[8].Shift = FaceSkeleton[c4d.ID_USERDATA,16]
	Trackers[9].Shift  = FaceSkeleton[c4d.ID_USERDATA,17]
	
	# get the sensibility data
	Trackers[0].Sen = FaceSkeleton[c4d.ID_USERDATA,43]
	Trackers[1].Sen = FaceSkeleton[c4d.ID_USERDATA,44]
	Trackers[2].Sen= FaceSkeleton[c4d.ID_USERDATA,45]
	
	Trackers[3].Sen= FaceSkeleton[c4d.ID_USERDATA,46]
	Trackers[4].Sen = FaceSkeleton[c4d.ID_USERDATA,47]
	Trackers[5].Sen = FaceSkeleton[c4d.ID_USERDATA,48]
	
	Trackers[6].Sen = FaceSkeleton[c4d.ID_USERDATA,39]
	Trackers[7].Sen= FaceSkeleton[c4d.ID_USERDATA,40]
	Trackers[8].Sen = FaceSkeleton[c4d.ID_USERDATA,41]
	Trackers[9].Sen= FaceSkeleton[c4d.ID_USERDATA,42]
	
	Trackers[0].Sen.z = FaceSkeleton[c4d.ID_USERDATA,34]
	Trackers[1].Sen.z = FaceSkeleton[c4d.ID_USERDATA,35]
	Trackers[2].Sen.z = FaceSkeleton[c4d.ID_USERDATA,36]
	
	Trackers[3].Sen.z= FaceSkeleton[c4d.ID_USERDATA,27]
	Trackers[4].Sen.z = FaceSkeleton[c4d.ID_USERDATA,28]
	Trackers[5].Sen.z = FaceSkeleton[c4d.ID_USERDATA,29]
	
	Trackers[6].Sen.z = FaceSkeleton[c4d.ID_USERDATA,30]
	Trackers[7].Sen.z= FaceSkeleton[c4d.ID_USERDATA,31]
	Trackers[8].Sen.z = FaceSkeleton[c4d.ID_USERDATA,32]
	Trackers[9].Sen.z= FaceSkeleton[c4d.ID_USERDATA,33]
	


	run = True;
	if Trackers[0].RawX is 0:
		run = False;
	

	
	# resize the Trackers Coordinates
	for i in range(0,10):
		Trackers[i].X =(Trackers[i].RawX) * (PlaneSize/1000)
		Trackers[i].Y =-((Trackers[i].RawY) * (PlaneSize/1000))
	
	
	if run is True:
		# this should be run just once
		if Par.Prepare is 1:
			for i in range(0,3):
				Trackers[i].Par =   c4d.Vector(0,0,0) 
				Trackers[i].bPos = Drivers[i].Driver.GetAbsPos()  
				Trackers[i].Diff=   c4d.Vector(Trackers[i].X ,Trackers[i].Y,0) 

			for i in range(3,6):
				Trackers[i].Par =  c4d.Vector(0,0,0) 
				Trackers[i].bPos = Drivers[i].Driver.GetAbsPos() 
				Trackers[i].Diff=  c4d.Vector(Trackers[i].X ,Trackers[i].Y,0) 
				
			for i in range(6,10):
				Trackers[i].Par =  Drivers[7].Driver.GetAbsPos()
				Trackers[i].bPos = Drivers[i].Driver.GetAbsPos() 
				Trackers[i].Diff=  c4d.Vector(Trackers[i].X ,Trackers[i].Y,0) 
			
			Par.Prepare = 0
	
		
		# final position calculation	
		if Par.Prepare is 0:
			for i in range(0,3):
				Trackers[i].Mult = LEyebrowPosMult
				Trackers[i].Add = LEyebrowPosAdd *( PlaneSize)
				
			for i in range(3,6):
				Trackers[i].Mult = REyebrowPosMult
				Trackers[i].Add = REyebrowPosAdd*( PlaneSize)
			
			for i in range(6,10):
				Trackers[i].Mult = MouthPosMult
				Trackers[i].Add = MouthPosAdd*( PlaneSize)
				
			
			for i in range(0,10):
				if Par.Abs == False:
					# relative positioning 
					X = Trackers[i].bPos.x + ((Trackers[i].Diff.x - Trackers[i].X ) * Trackers[i].Sen.z* Trackers[i].Sen.z *  Trackers[i].Sen.x)
					Y = Trackers[i].bPos.y + ((Trackers[i].Diff.y - Trackers[i].Y ) *  Trackers[i].Sen.z * Trackers[i].Sen.z *  Trackers[i].Sen.y) 
					Z = Trackers[i].bPos.z
					Trackers[i].Pos = c4d.Vector(X,Y,Z) 
					Trackers[i].Pos = Trackers[i].Pos + Trackers[i].Add 
					Trackers[i].Pos.x = Trackers[i].Pos.x  + (Trackers[i].Pos.x * Trackers[i].Shift.x)
					Trackers[i].Pos.y = Trackers[i].Pos.y +  (Trackers[i].Pos.y  *  Trackers[i].Shift.y)
				else:
					#absolute positioning
					if i is not 7:
						X= ((((Trackers[i].bPos.x-Trackers[i].Par.x)*(2-(2*(Trackers[i].Sen.x)))) + ((Trackers[i].X)*2*Trackers[i].Sen.x))/2) + Trackers[i].Par.x
						Y =((((Trackers[i].bPos.y-Trackers[i].Par.y)*(2-(2*(Trackers[i].Sen.y)))) + ((Trackers[i].Y)*2*Trackers[i].Sen.y))/2)+ Trackers[i].Par.y
						DiffX =( X - Trackers[i].bPos.x)*  Trackers[i].Sen.z
						X = Trackers[i].bPos.x + DiffX
						DiffY =( Y - Trackers[i].bPos.y)*  Trackers[i].Sen.z
						Y = Trackers[i].bPos.y + DiffY
						Z = Trackers[i].bPos.z
					else:
						X= Trackers[i].X + Trackers[i].Par.x
						Y =Trackers[i].Y + Trackers[i].Par.y
						Z = Trackers[i].bPos.z
					
					Trackers[i].Pos = c4d.Vector(X,Y,Z) 
					Trackers[i].Pos = Trackers[i].Pos + Trackers[i].Add 
					Trackers[i].Pos.x = Trackers[i].Pos.x  + (Trackers[i].Pos.x * Trackers[i].Shift.x)
					Trackers[i].Pos.y = Trackers[i].Pos.y +  (Trackers[i].Pos.y  *  Trackers[i].Shift.y)
				
		
				Drivers[i].Driver.SetAbsPos(Trackers[i].Pos)  # change the position

			# head rotation 
			HeadRotSen = FaceSkeleton[c4d.ID_USERDATA,13]
			BaseObjectRotation = Helpers[0].Base.GetAbsRot() 
			BaseObjectRotation.z = (Trackers[10].Angle / (360/(2*PI)))  * HeadRotSen
			Helpers[0].Base.SetAbsRot(BaseObjectRotation)

			# eyes rotation
			EyesRotSen = FaceSkeleton[c4d.ID_USERDATA,9]
			EyesRotation = Eyes[0].Object.GetAbsRot() 
			EyesRotation.x = (((Trackers[11].Direction / (360/(2*PI))) *0.09) * EyesRotSen)*(-1)
			Eyes[0].Object.SetAbsRot(EyesRotation)
			Eyes[1].Object.SetAbsRot(EyesRotation)

			ref = True
			
			
			if Par.Record is True:
				for i in range(0,10):
					SetKeyFrameXY(Drivers[i].Driver)  # set the key frames if the record is checked
				angle = "H"
				SetKeyFrameAngle(Eyes[0].Object,angle)	
				SetKeyFrameAngle(Eyes[1].Object,angle)	
				angle = "V"
				SetKeyFrameAngle(Helpers[0].Base,angle)	
	


	return True





# #################################### SECOND THREAD DEFINITION

class MyThread(c4d.threading.C4DThread):
	def Main(self):
		
		while True :
			if self.TestBreak(): # break the loop when thread ends 
				break 
			# #######################LOOP #######################
			res = GetDataFromTcpServer(TCP_IP_ADDRESS,int(TCP_PORT),BUFFER_SIZE)
			if res is True:
				Refresh()
			
			time.sleep((1/Par.Fps)*0.8) # sleep for a while 
			# ######################END OF LOOP ###################

TrackerThread = MyThread() # define the thread object 


# ####################################EXTERNAL FUNCTIONS 


def SetKeyFrameXY(MyObject): # set the X,Y key frames for the object
    Pos = MyObject.GetRelPos()
    ValueX = Pos .x
    ValueY = Pos .y
    doc = c4d.documents.GetActiveDocument()	
    # 01 Set up the tracks for X and Y position if they do not exist 
    TrackX = MyObject.FindCTrack(c4d.DescID(c4d.DescLevel(c4d.ID_BASEOBJECT_POSITION, c4d.DTYPE_VECTOR, 0), c4d.DescLevel(c4d.VECTOR_X, c4d.DTYPE_REAL, 0))) 
    if TrackX is None:
        TrackX = c4d.CTrack(MyObject,c4d.DescID(c4d.DescLevel(c4d.ID_BASEOBJECT_POSITION, c4d.DTYPE_VECTOR, 0), c4d.DescLevel(c4d.VECTOR_X, c4d.DTYPE_REAL, 0)))
        MyObject.InsertTrackSorted(TrackX)
    TrackY = MyObject.FindCTrack(c4d.DescID(c4d.DescLevel(c4d.ID_BASEOBJECT_POSITION, c4d.DTYPE_VECTOR, 0), c4d.DescLevel(c4d.VECTOR_Y, c4d.DTYPE_REAL, 0))) 
    if TrackY is None:
        TrackY = c4d.CTrack(MyObject,c4d.DescID(c4d.DescLevel(c4d.ID_BASEOBJECT_POSITION, c4d.DTYPE_VECTOR, 0), c4d.DescLevel(c4d.VECTOR_Y, c4d.DTYPE_REAL, 0)))
        MyObject.InsertTrackSorted(TrackY)  
    # 02 Then set up the curves and keys 
    CurveX = TrackX.GetCurve()
    CurveY = TrackY.GetCurve()
    KeyX = CurveX.AddKey(doc.GetTime())["key"]
    KeyY = CurveY.AddKey(doc.GetTime())["key"]
    # 03 Write values in to the keys
    KeyX.SetValue(CurveX,ValueX)
    KeyY.SetValue(CurveY,ValueY)
    
    return True
	
def SetKeyFrameAngle(MyObject,angle): # set the X,Y key frames for the object
	Rot = MyObject.GetRelRot()
	ValueH= Rot.x
	ValueS= Rot.y
	ValueV= Rot.z

	doc = c4d.documents.GetActiveDocument()	
	if angle is "H":
		TrackH = MyObject.FindCTrack(c4d.DescID(c4d.DescLevel(c4d.ID_BASEOBJECT_REL_ROTATION, c4d.DTYPE_VECTOR, 0), c4d.DescLevel(c4d.VECTOR_X, c4d.DTYPE_REAL, 0))) 
		if TrackH is None:
			TrackH = c4d.CTrack(MyObject,c4d.DescID(c4d.DescLevel(c4d.ID_BASEOBJECT_REL_ROTATION, c4d.DTYPE_VECTOR, 0), c4d.DescLevel(c4d.VECTOR_X, c4d.DTYPE_REAL, 0)))
			MyObject.InsertTrackSorted(TrackH)

		CurveH = TrackH.GetCurve()
		KeyH = CurveH.AddKey(doc.GetTime())["key"]
		KeyH.SetValue(CurveH,ValueH)
		
	if angle is "V":
		TrackV = MyObject.FindCTrack(c4d.DescID(c4d.DescLevel(c4d.ID_BASEOBJECT_REL_ROTATION, c4d.DTYPE_VECTOR, 0), c4d.DescLevel(c4d.VECTOR_Z, c4d.DTYPE_REAL, 0))) 
		if TrackV is None:
			TrackV = c4d.CTrack(MyObject,c4d.DescID(c4d.DescLevel(c4d.ID_BASEOBJECT_REL_ROTATION, c4d.DTYPE_VECTOR, 0), c4d.DescLevel(c4d.VECTOR_Z, c4d.DTYPE_REAL, 0)))
			MyObject.InsertTrackSorted(TrackV)

		CurveV = TrackV.GetCurve()
		KeyV = CurveV.AddKey(doc.GetTime())["key"]
		KeyV.SetValue(CurveV,ValueV)
    
	return True	

def ClearTrackXY():
		for i in range(0,10):
			for track in Drivers[i].Driver.GetCTracks():
				track.Remove()	
		for i in range(0,2):
			for track in Eyes[i].Object.GetCTracks():
				track.Remove()	

		for track in Helpers[0].Base.GetCTracks():
			track.Remove()						

def GetDataFromTcpServer(IP,PORT,BUFFER):
	s = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
	res = s.connect_ex((IP,PORT))
	
	doc = c4d.documents.GetActiveDocument()	

	if res> 0:
		print "No Server Connection"
		Result = False
	else:
		Result  = True

		data = s.recv(BUFFER)
		
		Header = str(data[0:4])
			
		x = 4
		for i in range(0,10):
			Xsign =  int(data[x:x+1])
			Trackers[i].RawX = int(data[x+1:x+4]) 
			if Xsign is 0:
				Trackers[i].RawX = -Trackers[i].RawX 
			Ysign =  int(data[x+4:x+5])
			Trackers[i].RawY = int(data[x+5:x+8]) 
			if Ysign is 0:
				Trackers[i].RawY = -Trackers[i].RawY 
			x = x+8
			
			
		#get the angle value
		AngleSign =  int(data[x:x+1])
		x = x+1
		Angle =  int(data[x:x+2])
		x = x+2
		if AngleSign is 0:
			Trackers[10].Angle = Angle
		if AngleSign is 1:
			Trackers[10].Angle = Angle
			
			
		#get the direction value
		EyeSign =  int(data[x:x+1])
		x = x+1
		Direction =  int(data[x:x+4])

		if EyeSign is 0:
			Trackers[11].Direction = Direction
		if EyeSign is 1:
			Trackers[11].Direction = Direction	
		
	
	
	s.close()

	return Result
    

def VectorDistance(VecA,VecB): # calculate the distance of two 3D vectors 
	Distance  =  math.sqrt(math.pow((VecA.x-VecB.x),2)  + math.pow((VecA.y-VecB.y),2)  + math.pow((VecA.z-VecB.z),2) )
	return Distance

	
def VectorSize(VecA): # calculate the distance of two 3D vectors 
	Size  =  math.sqrt(math.pow((VecA.x),2)  + math.pow((VecA.y),2)  + math.pow((VecA.z),2) )
	return Size

	
def GetCurrentFrame(): # returns the current frame
    doc = c4d.documents.GetActiveDocument()	
    cFrame = doc.GetTime().GetFrame(doc.GetFps())  
    return cFrame
	
def GetCurrentTime():
		dt = datetime.now()
		time = dt.microsecond/1000
		return time

def GetDelay():
		CurTime = GetCurrentTime()
		delay = math.fabs(CurTime - Par.Buffer01)
		Par.Buffer01 = CurTime
		return delay	
	
# ####################################EXTERNAL CLASSES 

class Tracker(object):
	def __init__(self,RawX=None,RawY=None,X = None,Y = None, Mult = None,bPos= None,Pos =None,Shift = None,Add = None,Par = None,Diff=None,Angle= None,Direction=None,Sen=None):
		
		self.RawX = RawX
		self.RawY = RawY
		self.X = X
		self.Y = Y
		self.Mult = Mult
		self.bPos = bPos
		self.Pos = Pos
		self.Shift = Shift
		self.Add = Add
		self.Par = Par
		self.Diff = Diff
		self.Angle = Angle 
		self.Direction= Direction
		self.Sen = Sen
		
		
		
class Driver(object):
	def __init__(self,Driver = None,BaseBone = None,TipBone = None,Parent = None,ParentPos = None):
		
		self.Driver = Driver
		self.BaseBone = BaseBone
		self.TipBone = TipBone
		self.Parent = Parent
		self.ParentPos = ParentPos

		
class Eye(object):
	def __init__(self,Object= None,Angle = None,Mult= None):
		
		self.Object = Object
		self.Angle= Angle
		self.Mult= Mult


class Helper(object):
	def __init__(self,Plane= None,Base = None):
		
		self.Plane = Plane
		self.Base= Base

		
		
class Parameter(object):
	def __init__(self,Run = None,Record = None,Frame = None,Buffer01 = None,Prepare = None,Abs =None,Dfps = None,Rfps = None,MinFrame = None,MaxFrame = None, CurFrame = None,Fps = None):
		
		self.Run = Run
		self.Record = Record
		self.Frame = Frame
		self.Buffer01 = Buffer01
		self.Prepare = Prepare
		self.Abs = Abs
		self.Dfps = Dfps
		self.Rfps = Rfps
		
		self.MinFrame = MinFrame
		self.MaxFrame = MaxFrame
		self.CurFrame = CurFrame
		self.Fps= Fps
		

Par = Parameter(False,False,99999999,0,1,False,0,0,0,0,0,0)



class BaseObjects(object):
	def __init__(self,FaceSkeleton = None,FaceMesh= None):
		
		self.FaceSkeleton = FaceSkeleton 
		self.FaceMesh = FaceMesh 
		

Obj = BaseObjects(c4d.BaseObject,c4d.BaseObject )




# ###################################### LISTS ALLOCATION

Trackers = []  # fill the trackers list
for i in range(0,13):
	Trackers.append(Tracker(0,0,0,0,0,c4d.Vector,c4d.Vector,c4d.Vector,c4d.Vector,c4d.Vector,c4d.Vector,0,0,c4d.Vector))


Drivers = []  # fill the trackers list
for i in range(0,16):
	Drivers.append(Driver(c4d.BaseObject,0,0,0,0))
	
Eyes= []  # fill the eyes list
for i in range(0,2):
	Eyes.append(Eye(c4d.BaseObject,0,0))


Helpers= []  # fill the eyes list
for i in range(0,1):
	Helpers.append(Helper(c4d.BaseObject,c4d.BaseObject))    

# ########################################## GUI
	

class FaceTrackerDialog(c4d.gui.GeDialog): # the core 

	def CreateLayout(self):            # create the pug-ins layout , self is always the first parameter it is pointer to the object we are created #########################
		self.SetTitle("FaceTracker 1.0")     # title for the plug-in
		doc = c4d.documents.GetActiveDocument()	


		#Group with 2 columns and 0 rows
		self.GroupBegin(20001, c4d.BFH_SCALEFIT | c4d.BFV_SCALEFIT, 2, 0, "")   # group begins 
		self.rootLinkBaseContainer = c4d.BaseContainer()
		self.AddStaticText(0, c4d.BFH_LEFT, 0, 0, "Face Skeleton:", 0)   # text label 
		self.link_skeleton = self.AddCustomGui(UI_LNK_SKELETON, c4d.CUSTOMGUI_LINKBOX, "", c4d.BFH_SCALEFIT, 100, 10, self.rootLinkBaseContainer)
		self.AddStaticText(0, c4d.BFH_LEFT, 0, 0, "Face Mesh:", 0)
		self.link_mesh = self.AddCustomGui(UI_LNK_MESH, c4d.CUSTOMGUI_LINKBOX, "", c4d.BFH_SCALEFIT, 100, 10, self.rootLinkBaseContainer)
		self.GroupEnd()   # group ends 
		self.AddSeparatorH(0, flags=c4d.BFH_SCALEFIT)	
		#Group with 3 columns
		self.GroupBegin(20001, c4d.BFH_SCALEFIT | c4d.BFV_SCALEFIT, 3, 0, "")
		self.AddButton(UI_BT_LOAD, c4d.BFH_LEFT | c4d.BFV_TOP | c4d.BFH_SCALEFIT, 200, 15, "Load Face Skeleton")
		self.AddButton(UI_BT_BIND, c4d.BFH_LEFT | c4d.BFV_TOP | c4d.BFH_SCALEFIT, 200, 15, "Bind Mesh")
		self.AddButton(UI_BT_EDIT, c4d.BFH_LEFT | c4d.BFV_TOP | c4d.BFH_SCALEFIT, 200, 15, "Edit")
		self.GroupEnd()



		self.AddSeparatorH(0, flags=c4d.BFH_SCALEFIT)		
		#Group with 3 columns
		self.GroupBegin(20001, c4d.BFH_SCALEFIT | c4d.BFV_SCALEFIT, 3, 0, "")
		self.AddButton(UI_BT_SAVEFP, c4d.BFH_LEFT | c4d.BFV_TOP | c4d.BFH_SCALEFIT, 200, 15, "Save Face")
		self.AddButton(UI_BT_LOADFP , c4d.BFH_LEFT | c4d.BFV_TOP | c4d.BFH_SCALEFIT, 200, 15, "Load Face")
		self.AddButton(UI_BT_DEFAULT , c4d.BFH_LEFT | c4d.BFV_TOP | c4d.BFH_SCALEFIT, 200, 15, "Reset User Data")
		self.GroupEnd()

		self.AddSeparatorH(0, flags=c4d.BFH_SCALEFIT)	

		self.GroupBegin(20001, c4d.BFH_SCALEFIT | c4d.BFV_SCALEFIT, 6, 0, "")   # group begins 
		self.rootLinkBaseContainer = c4d.BaseContainer()
		self.AddStaticText(0, c4d.BFH_LEFT, 0, 0, "TCP IP:", 0)   # text label 
		self.AddEditText(UI_T_IP,flags=c4d.BFH_LEFT |c4d.BFV_TOP,initw=150,inith=15)
		self.AddStaticText(0, c4d.BFH_LEFT, 0, 0, "TCP PORT:", 0) # text label 
		self.AddEditText(UI_T_PORT,flags=c4d.BFH_LEFT |c4d.BFV_TOP,initw=50,inith=15)
		self.AddCheckbox(UI_CH_REC,flags=c4d.BFH_LEFT |c4d.BFV_CENTER, initw=100, inith=15, name="Record")
		self.AddCheckbox(UI_CH_ABS,flags=c4d.BFH_LEFT |c4d.BFV_CENTER, initw=200, inith=15, name="Absolute Positioning")
		self.GroupEnd() # group ends 


		self.AddSeparatorH(0, flags=c4d.BFH_SCALEFIT)	

		self.GroupBegin(20001, c4d.BFH_SCALEFIT | c4d.BFV_SCALEFIT, 2 ,0, "")   # group begins 
		self.rootLinkBaseContainer = c4d.BaseContainer()
		self.AddButton(UI_BT_DEL, c4d.BFH_LEFT | c4d.BFV_TOP | c4d.BFH_SCALEFIT, 250, 15, "Delete Records")
		self.AddButton(UI_BT_RUN, c4d.BFH_LEFT | c4d.BFV_TOP | c4d.BFH_SCALEFIT, 250, 15, "Run")
		self.GroupEnd() # group ends 



		self.SetString(UI_T_IP,TCP_IP_ADDRESS) 
		self.SetString(UI_T_PORT,TCP_PORT) 
		self.SetReal(UI_EN_DOCFPS,doc.GetFps()) 
		self.SetString(UI_EN_REAFPS,0) 		
		
		
		
		return True 
		
	def Timer(self, msg):
		
		c4d.EventAdd()	
		
		
# ####################################### COMMAND PART

	def Command(self, id, msg): 
	# id is the id number of the object the command was issued from, usually a button



		doc = c4d.documents.GetActiveDocument()
		TCP_IP_ADDRESS = self.GetString(UI_T_IP)
		Par.Record = self.GetBool(UI_CH_REC)
		Par.Abs = self.GetBool(UI_CH_ABS)

		self.SetFloat(UI_EN_REAFPS,float(Par.Rfps)) 
		Par.Dfps = self.GetReal(UI_EN_DOCFPS) 

		if id == UI_EN_DOCFPS:
			doc.SetFps(int(Par.Dfps))


		if id == UI_BT_DEL:

			ClearTrackXY()
			c4d.EventAdd()


		if id==UI_BT_RUN: # run the server 
			

			if self.GetString(UI_BT_RUN)  == "Run":
				self.SetString(UI_BT_RUN,"Stop")
				Par.Run = True

				Obj.FaceMesh = self.link_mesh.GetLink() # DELETE
				
				# get the time values 
				Par.MinFrame = int(doc.GetMinTime().Get() * doc.GetFps())
				Par.MaxFrame = int(doc.GetMaxTime().Get() * doc.GetFps())
				Par.CurFrame = GetCurrentFrame()
				Par.Fps = doc.GetFps()

				TrackerThread.Start() # start the second thread 
				self.SetTimer((int(1/Par.Fps)*1000))
				c4d.CallCommand(ID_PLAY)



			else:
				self.SetTimer(0)
				self.SetString(UI_BT_RUN,"Run")
				TrackerThread.End() # stop the second thread
				c4d.CallCommand(ID_PLAY)
				Par.Run = False
				c4d.EventAdd()
		

		if id==UI_BT_SAVEFP: # save the current face play
			DirName , PlugInName= os.path.split(os.path.abspath(__file__))
			FileName= '\\res\Data.txt'
			FileName = DirName + FileName
			file = open(FileName, "w")

			for i in range(0,10):
				pos = Drivers[i].Driver.GetAbsPos()
				string = "%.3f" % pos.x
				file.write(string) 
				file.write("\n")
				string = "%.3f" % pos.y
				file.write(string) 
				file.write("\n")
				string = "%.3f" % pos.z
				file.write(string) 
				file.write("\n")

			string = "%.3f" % Eyes[0].Object.GetAbsRot().x # write the eyes rotation
			file.write(string) 
			file.write("\n")

			string = "%.3f" % Eyes[1].Object.GetAbsRot().x # write the eyes rotation
			file.write(string) 
			file.write("\n")
			
			string = "%.3f" % Helpers[0].Base.GetAbsRot().z # write head rotation
			file.write(string) 
			file.write("\n")

			file.close()

			c4d.EventAdd()	


		if id==UI_BT_DEFAULT: # reset the user data to default

			FaceSkeleton = Helpers[0].Base
			FaceSkeleton[c4d.ID_USERDATA,13] = 1
			FaceSkeleton[c4d.ID_USERDATA,9] = 1
			FaceSkeleton[c4d.ID_USERDATA,2] = 1
			FaceSkeleton[c4d.ID_USERDATA,3] = c4d.Vector(0,0,0)
			FaceSkeleton[c4d.ID_USERDATA,14] = c4d.Vector(0,0,0)
			FaceSkeleton[c4d.ID_USERDATA,15] = c4d.Vector(0,0,0)
			FaceSkeleton[c4d.ID_USERDATA,16] = c4d.Vector(0,0,0)
			FaceSkeleton[c4d.ID_USERDATA,17] = c4d.Vector(0,0,0)
			FaceSkeleton[c4d.ID_USERDATA,10] = 1
			FaceSkeleton[c4d.ID_USERDATA,5] = c4d.Vector(0,0,0)
			FaceSkeleton[c4d.ID_USERDATA,20] = c4d.Vector(0,0,0)
			FaceSkeleton[c4d.ID_USERDATA,21] = c4d.Vector(0,0,0)
			FaceSkeleton[c4d.ID_USERDATA,22] = c4d.Vector(0,0,0)
			FaceSkeleton[c4d.ID_USERDATA,11] = 1
			FaceSkeleton[c4d.ID_USERDATA,8] = c4d.Vector(0,0,0)
			FaceSkeleton[c4d.ID_USERDATA,24] = c4d.Vector(0,0,0)
			FaceSkeleton[c4d.ID_USERDATA,25] =c4d.Vector(0,0,0)
			FaceSkeleton[c4d.ID_USERDATA,26] =c4d.Vector(0,0,0)
			FaceSkeleton[c4d.ID_USERDATA,27] = 1
			FaceSkeleton[c4d.ID_USERDATA,28] = 1
			FaceSkeleton[c4d.ID_USERDATA,29] = 1
			FaceSkeleton[c4d.ID_USERDATA,30] = 1
			FaceSkeleton[c4d.ID_USERDATA,31] = 1
			FaceSkeleton[c4d.ID_USERDATA,32] = 1
			FaceSkeleton[c4d.ID_USERDATA,33] = 1
			FaceSkeleton[c4d.ID_USERDATA,34] = 1
			FaceSkeleton[c4d.ID_USERDATA,35] = 1
			FaceSkeleton[c4d.ID_USERDATA,36] = 1
			FaceSkeleton[c4d.ID_USERDATA,39] = c4d.Vector(1,1,0)
			FaceSkeleton[c4d.ID_USERDATA,40] = c4d.Vector(1,1,0)
			FaceSkeleton[c4d.ID_USERDATA,41] = c4d.Vector(1,1,0)
			FaceSkeleton[c4d.ID_USERDATA,42] = c4d.Vector(1,1,0)
			FaceSkeleton[c4d.ID_USERDATA,43] = c4d.Vector(1,1,0)
			FaceSkeleton[c4d.ID_USERDATA,44] = c4d.Vector(1,1,0)
			FaceSkeleton[c4d.ID_USERDATA,45] = c4d.Vector(1,1,0)
			FaceSkeleton[c4d.ID_USERDATA,46] = c4d.Vector(1,1,0)
			FaceSkeleton[c4d.ID_USERDATA,47] = c4d.Vector(1,1,0)
			FaceSkeleton[c4d.ID_USERDATA,48] = c4d.Vector(1,1,0)
			
			c4d.EventAdd()	



		if id==UI_BT_LOADFP: # load the current face play
			DirName , PlugInName= os.path.split(os.path.abspath(__file__))
			FileName= '\\res\Data.txt'
			FileName = DirName + FileName
			file = open(FileName, "r")

			for i in range(0,10):

				x = file.readline()
				y = file.readline()
				z = file.readline()
				pos = c4d.Vector(float(x),float(y),float(z))
				Drivers[i].Driver.SetAbsPos(pos)

			rot = file.readline()
			Eyes[0].Object.SetAbsRot(c4d.Vector(float(rot),0,0))

			rot = file.readline()
			Eyes[1].Object.SetAbsRot(c4d.Vector(float(rot),0,0))
			
			rot = file.readline()
			Helpers[0].Base.SetAbsRot(c4d.Vector(0,0,float(rot)))
			

			file.close()
			c4d.EventAdd()	


		if id==UI_BT_LOAD: # load the face skeleton inside document 

			DirName , PlugInName= os.path.split(os.path.abspath(__file__))
			FileName= '\\res\FaceSkeleton.c4d'
			FileName = DirName + FileName

			ObjectName01 = "FaceSkeleton" 
			if c4d.documents.MergeDocument(doc,FileName,c4d.SCENEFILTER_OBJECTS ) is True :
				print "FaceSkeleton was successfully loaded!"
			else:
				print "FaceSkeleton wasn't found! Please Re-Install Plug-In!"


			c4d.EventAdd()


		if id == UI_BT_EDIT: # 01 delete the skin object and weight tag

			ObjMesh = self.link_mesh.GetLink()
			ObjSkin = ObjMesh.GetDown()
			doc.SetActiveObject(ObjSkin,c4d.SELECTION_NEW)
			c4d.CallCommand(ID_DELETE)
			ObjMesh.KillTag(WEIGHT_TAG_ID)

		if id==UI_LNK_SKELETON: # initialize the face skeleton

			ObjSkeleton = self.link_skeleton.GetLink() 

			Helpers[0].Base = ObjSkeleton
			Helpers[0].Plane = ObjSkeleton.GetDown().GetNext().GetNext().GetNext().GetNext()

			# Mouth 
			Drivers[12].Driver =  ObjSkeleton.GetDown()
			Drivers[6].Driver =  ObjSkeleton.GetDown().GetDown().GetDown()
			Drivers[7].Driver =  Drivers[6].Driver.GetNext() 
			Drivers[8].Driver =  Drivers[7].Driver.GetNext() 
			Drivers[9].Driver =  Drivers[8].Driver.GetNext() 
			Drivers[13].Driver =  Drivers[9].Driver.GetDown() 

			# Left EyeBrow
			Drivers[10].Driver =  ObjSkeleton.GetDown().GetNext()
			Drivers[0].Driver =  ObjSkeleton.GetDown().GetNext().GetDown().GetDown()
			Drivers[1].Driver =  Drivers[0].Driver.GetNext() 
			Drivers[2].Driver =  Drivers[1].Driver.GetNext() 
			Eyes[0].Object  =   Drivers[2].Driver.GetNext() 

			# Right EyeBrow
			Drivers[11].Driver =  ObjSkeleton.GetDown().GetNext().GetNext()
			Drivers[3].Driver =  ObjSkeleton.GetDown().GetNext().GetNext().GetDown().GetDown()
			Drivers[4].Driver =  Drivers[3].Driver.GetNext() 
			Drivers[5].Driver =  Drivers[4].Driver.GetNext() 
			Eyes[1].Object  =   Drivers[5].Driver.GetNext() 
			
			# the bones

			# the mouth 
			Drivers[6].BaseBone =  Helpers[0].Base.GetDown().GetDown().GetNext().GetDown()
			Drivers[7].BaseBone =  Drivers[6].BaseBone.GetNext()
			Drivers[8].BaseBone =  Drivers[7].BaseBone.GetNext()
			Drivers[9].BaseBone =  Drivers[8].BaseBone.GetNext()
			Drivers[12].BaseBone =  Drivers[9].BaseBone.GetNext()

			# the L EyeBrow
			Drivers[0].BaseBone =  Helpers[0].Base.GetDown().GetNext().GetDown().GetNext().GetDown()
			Drivers[1].BaseBone =  Drivers[0].BaseBone.GetNext()
			Drivers[2].BaseBone =  Drivers[1].BaseBone.GetNext()
			Drivers[10].BaseBone =  Drivers[2].BaseBone.GetNext()

			# the R EyeBrow
			Drivers[3].BaseBone =  Helpers[0].Base.GetDown().GetNext().GetNext().GetDown().GetNext().GetDown()
			Drivers[4].BaseBone =  Drivers[3].BaseBone.GetNext()
			Drivers[5].BaseBone =  Drivers[4].BaseBone.GetNext()
			Drivers[11].BaseBone =  Drivers[5].BaseBone.GetNext()

			
			 

			# tip bones 
			Drivers[0].TipBone =  Helpers[0].Base.GetDown().GetNext().GetNext().GetNext().GetNext().GetNext().GetDown()
			for i in range(1,14):
				Drivers[i].TipBone = Drivers[i-1].TipBone.GetNext() # get the tip joints
			Drivers[14].TipBone = Drivers[13].TipBone .GetDown()



		if id == UI_BT_BIND:
			# 01 define the face skeleton and face mesh and select the mesh
			ObjMesh = self.link_mesh.GetLink()
			doc.SetActiveObject(ObjMesh,c4d.SELECTION_NEW)
			ObjSkeleton = self.link_skeleton.GetLink()
		

			for i in range(0,10): # set base bones lengths
				VECTOR = Drivers[i].Driver.GetAbsPos() 
				Drivers[i].BaseBone[c4d.ID_CA_JOINT_OBJECT_LENGTH] =  VectorSize(VECTOR)

				VECTOR = Drivers[13].Driver.GetAbsPos() + Drivers[9].Driver.GetAbsPos()
				Drivers[12].BaseBone[c4d.ID_CA_JOINT_OBJECT_LENGTH] =  VectorSize(VECTOR)

			for i in range(0,15): # add the bones to the selection
				doc.SetActiveObject(Drivers[i].TipBone,c4d.SELECTION_ADD)
				#doc.SetActiveObject(Drivers[i].BaseBone,c4d.SELECTION_ADD)

			#doc.SetActiveObject(Drivers[13].BaseBone,c4d.SELECTION_ADD)




			c4d.CallCommand(ID_BIND)

		
		c4d.EventAdd()
		
   



		return True	

  



class FaceTracker(c4d.plugins.CommandData): # BASE CLASS OF COMMAND DATA PLUGIN

    dialog = None

    def Init(self, op):
        return True


    def Execute(self, doc):   # this function will be executed when the plug-in starts 
        if self.dialog is None:
            self.dialog = FaceTrackerDialog()  
        return self.dialog.Open(dlgtype=c4d.DLG_TYPE_ASYNC, pluginid=PLUGIN_ID, defaultw=400, defaulth=160)


	def PluginEnd():
		TrackerThread.End() 
		MainThread.End()
		return True

# #################################### MAIN FUNCTION
		
if __name__ == '__main__':
    bmp = c4d.bitmaps.BaseBitmap()
    dir, file = os.path.split(__file__)
    fn = os.path.join(dir, "res", "Icon.tif")
    bmp.InitWith(fn)
    print "FaceTracker 1.0 plug-in initialized."
    result = plugins.RegisterCommandPlugin(PLUGIN_ID, "FaceTracker", 0, bmp, "FaceTracker", FaceTracker())
